package jagoclient.ascii;
 
import jagoclient.Go;
import jagoclient.board.*;
import jagoclient.ascii.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
 
import rene.util.list.*;
import rene.util.xml.*;
 
//******************* Board ***********************
 
/**
AsciiBoard extends Board
the main file for presenting a Go board.
<P>
Handles the complete display and storage of a Go board.
The display is kept on an offscreen image.
Stores a Go game in a node list (with variants).
Handles the display of the current node.
<P>
This class handles mouse input to set the next move.
It also has methods to move in the node tree from external sources.
<P>
A BoardInterface is used to encorporate the board
into an environment.
*/
 
public class AsciiBoard extends Board
{
   int lasti=-1,lastj=0; // last move (used to highlight the move)
   boolean showlast; // internal flag, if last move is to be highlighted
      // offscreen images of empty and current board
   SGFTree T; // the game tree
   Vector Trees; // the game trees (one of them is T)
   int CurrentTree; // the currently displayed tree
   Position P; // current board position
   int number; // number of the next move
   TreeNode Pos; // the current board position in this presentation
   Font font; // Font for board letters and coordinates
   FontMetrics fontmetrics; // metrics of this font
   int MainColor=1;
   public int MyColor=0;
   int sendi=-1,sendj;
      // board position which has been sended to server
   Dimension Dim; // Note size to check for resizeing at paint
   String TextMarker="A";
   public int Pw,Pb; // Prisoners (white and black)
   BufferedReader LaterLoad=null; // File to be loaded at repaint
   Image BlackStone,WhiteStone;
   int Range=-1; // Numbers display from this one
   boolean KeepRange=false;
   String NodeName="",LText="";
   boolean DisplayNodeName=false;
   public boolean Removing=false;
   boolean Activated=false;
   public boolean Teaching=false; // enable teaching mode
 
   // ******************** initialize board *******************
 
   public AsciiBoard (int size, BoardInterface gf)
   {  super(size,gf);}
 
 
 
   public void mouseReleased (MouseEvent e)
   // handle mouse input
   {  
   if (!MouseDown) return;
       int x=e.getX(),y=e.getY();
      MouseDown=false;
      if (ActiveImage==null) return;
      if (!Active) return;
      if (GF.blocked() && Pos.isLastMain()) return;
      getinformation();
      x-=O+OTU; y-=O+OTU;
      int i=x/D,j=y/D; // determine position
      if (x<0 || y<0 || i<0 || j<0 || i>=S || j>=S) return;
      switch (State)
      {  case 3 : // set a black stone
         case 4 : // set a white stone
            break;
         case 5 : mark(i,j); break;
         case 6 : letter(i,j); break;
         case 7 : // delete a stone
         case 8 : // remove a group
         case 9 : 
         case 10 : 
         break;
         case 1 :
         case 2 : // normal move mode
            if (e.isShiftDown()) // create variation
            { 
            }
            else if (e.isControlDown())
               // goto variation
            {  
            }
            else if (e.isMetaDown()) // right click
            {  
            }
            else // place a W or B stone
            {  movemouse(i,j);
        if ( Go.gnugoInputDir != null)
               asciiStoneOutput(i,j);
            }
            break;
      }
      showinformation();
      copy(); // show position
   }
 
   void asciiStoneOutput(int i,int j)
{
char formatx[] = {'a' ,'b','c','d','e','f','g','h','j','k','l',
'm','n','o','p','q','r','s','t'} ;
 
byte newbyte[]=new byte [4];
 
int jj, nobyte;
 
 
    jj=Go.BOARDSIZE-j;
    newbyte[0] = (byte) formatx[i];
    newbyte[1] = (byte) (jj/10+48);
    newbyte[2] = (byte) (jj%10+48);
    newbyte[3] = (byte) (10);
    nobyte=4;
    asciiOutput(newbyte, nobyte);
}
 
 
 
 static public void asciiOutput(byte [] newbyte, int nobyte)
   {
 
String javaDataFile = "javaData";
String javaReplFile = "javaRepl";
BufferedOutputStream hinaus = null;
 
String gnugoInputDir = Go.getGnugoDir() ;
File javaData = new File ( gnugoInputDir , javaDataFile ) ;
 
 
 
   try {
         hinaus = new BufferedOutputStream (
                          new FileOutputStream ( javaData) );
       } catch (Exception e) { System.out.println("error " + e);}
 
   try {
         hinaus.write(newbyte,0,nobyte);
         hinaus.flush();
        } catch (Exception e) { System.out.println("error " + e);}
 
   try {
         Thread.sleep(100);
       } catch (InterruptedException e) {}

         File javaRepl = new File ( gnugoInputDir , javaReplFile ) ;

   try {
         FileOutputStream raus = new FileOutputStream ( javaRepl);
         raus.write(1);
         raus.flush();
       } catch (Exception e) { System.out.println("error " + e);}



   }
}
