package jagoclient.gmp;

import jagoclient.Global;
import jagoclient.Dump;
import jagoclient.board.*;
import jagoclient.dialogs.*;

public class GMPGoFrame extends ConnectedGoFrame
{	GMPConnection C;
	boolean WantMove=true;
	public GMPGoFrame (GMPConnection c, int size)
	{	super(Global.resourceString("Play_Go"),size,
			Global.resourceString("Remove_groups"),Global.resourceString(""),
			false,false);
		C=c;
	}
	public boolean wantsmove ()
	{	return WantMove;
	}
	public void gotMove (int color, int i, int j)
	{	if (color==GMPConnector.WHITE) white(i,j);
		else black(i,j);
	}
	public void gotSet (int color, int i, int j)
	{	if (color==GMPConnector.WHITE) setwhite(i,j);
		else setblack(i,j);
	}
	public void gotPass (int color)
	{	Dump.println("Opponent passed");
		B.pass();
		Message d=new Message(this,Global.resourceString("Pass"));
	}
	public void notepass ()
	{	Dump.println("I pass");
		C.moveset(-1,0);
	}
	public boolean moveset (int i, int j)
	{	Dump.println("Move at "+i+" "+j);
		C.moveset(i,j);
		return true;
	}
	public void color (int c)
	{	if (c==GMPConnector.WHITE) super.color(-1);
		else super.color(1);
	}
	public void undo ()
	{	//C.askUndo();
	}
	public void doundo (int n)
	{	B.undo(n);
	}

	public void doAction (String o)	
	{	if (Global.resourceString("Remove_groups").equals(o))
		{	WantMove=false;
			B.score();
		}
		else super.doAction(o);
	}

	public void doclose ()
	{	C.doclose();
		super.doclose();
	}
}
